import { BULLET_SIZE, FONT_SIZE, TOT_SHOTS } from './Constants.js';
import { Gun } from './Gun.js';
import { Target } from './Target';

import bullet from '../data/bullet.png';


class ScoreDisplay {
  constructor(initialBullets) {
    this.bulletImg = null;
    this.shotLeft = initialBullets;
    this.score = 0;

    loadImage(bullet, (img) => {
      this.bulletImg = img;
    });
  }

  draw() {
    // Draw score on top-left
    textFont('Arial');
    textSize(25);
    fill(255, 0, 0);
    textAlign(LEFT, TOP);
    text(`Score: ${this.score}`, 10, 10);

    if (!this.bulletImg) return;

    // Draw remaining bullets on top-right
    const bulletSpacing = 20;
    const marginRight = 10;
    const bulletsWidth = this.shotLeft * bulletSpacing;
    let startX = width - bulletsWidth - marginRight;
    let y = 10;

    for (let i = 0; i < this.shotLeft; i++) {
      image(this.bulletImg, startX + i * bulletSpacing, y, BULLET_SIZE, BULLET_SIZE);
    }

  }

  update(source, ...others) {
    if (source === 'gun') {
      const [, , remainingShots] = others;
      this.shotLeft = remainingShots;
    } else if (source === 'target-hit') {
      const [points] = others;
      this.score += points;
    }
  }
}

export { ScoreDisplay };
